SystemOrganization addCategory: 'Iliad-GemStone-Core-Platform'!
SystemOrganization addCategory: 'Iliad-GemStone-Core-Utilities'!

RemoteDebuggerLogEntry subclass: #ILObjectLogEntry
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-GemStone-Core-Platform'!

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
debug: aString request: aWARequest object: anObject

	^(self debug: aString object: anObject)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
error: aString request: aWARequest continuation: aGsProcess

	^(self error: aString continuation: aGsProcess)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
error: aString request: aWARequest object: anObject

	^(self error: aString object: anObject)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
fatal: aString request: aWARequest object: anObject

	^(self fatal: aString object: anObject)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
info: aString request: aWARequest object: anObject

	^(self info: aString object: anObject)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
trace: aString request: aWARequest object: anObject

	^(self trace: aString object: anObject)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
transcript: aString request: aWARequest object: anObject

	^(self transcript: aString object: anObject)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry class methodsFor: 'instance creation' stamp: 'NicolasPetton 07/08/2011 14:35'!
warn: aString request: aWARequest object: anObject

	^(self warn: aString object: anObject)
		request: aWARequest;
		yourself! !

!ILObjectLogEntry methodsFor: 'testing' stamp: 'NicolasPetton 07/08/2011 14:35'!
isResumable
	"disable resume for continuations until bugs relating to resuming are fixed.
	 Issue 128: http://code.google.com/p/glassdb/issues/detail?id=128"
	
	^false! !

!ILObjectLogEntry methodsFor: 'accessing' stamp: 'NicolasPetton 07/08/2011 14:35'!
request

	^request! !

!ILObjectLogEntry methodsFor: 'accessing' stamp: 'NicolasPetton 07/08/2011 14:35'!
request: aWARequest

	request := aWARequest! !

!ILObjectLogEntry methodsFor: 'accessing' stamp: 'NicolasPetton 07/08/2011 14:35'!
requestString

	self request == nil ifTrue: [ ^super requestString ].
	^self request url asString! !

!ILErrorHandler methodsFor: '*iliad-gemstone-core' stamp: 'NicolasPetton 07/08/2011 14:28'!
produceDebugResponse
	ILPlatform current openDebuggerOn: self error! !

ILPlatform subclass: #ILGemstonePlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-GemStone-Core-Platform'!

!ILGemstonePlatform class methodsFor: 'initialization' stamp: 'SebastienAudier 7/7/2011 16:16'!
initialize
	self setCurrent! !

!ILGemstonePlatform class methodsFor: 'testing' stamp: 'NicolasPetton 07/06/2011 19:41'!
isConcrete
	^true! !

!ILGemstonePlatform methodsFor: 'utilities' stamp: 'NicolasPetton 07/06/2011 19:39'!
categoryOfSelector: aSelector inClass: aClass
	^aClass categoryOfSelector: aSelector! !

!ILGemstonePlatform methodsFor: 'utilities' stamp: 'SebastienAudier 07/07/2011 15:00'!
convertStringToNumber: aString
	^(aString copyReplaceAll: '.' with: ',') asNumber! !

!ILGemstonePlatform methodsFor: 'utilities' stamp: 'SebastienAudier 07/07/2011 14:42'!
getStreamPosition: aStream
	^aStream position - 1! !

!ILGemstonePlatform methodsFor: 'debugging' stamp: 'NicolasPetton 07/08/2011 14:53'!
openDebuggerOn: anException
	"From Seasde 3.0.
	See WARemoteDebuggingWalkbackErrorHandler"
	
	| continuation action |
	GRPlatform current canDebugInteractively
		ifTrue: [
			(anException isKindOf: Error) 
				ifFalse: [anException pass].
			^super openDebuggerOn: anException].
		
	action := [:cont | continuation := cont. #create ] callCC.
	action == #create
		ifTrue: [
			[| logEntry|
				logEntry := ILObjectLogEntry 
					error: anException description 
					request: ILCurrentContext value request
					continuation: continuation.
					"the continuation is not resumable"
					logEntry resumeContinuation.
					logEntry addToLog]
						on: Error
						do: [:err | ].
			^self].
	action == #debug
		ifTrue: [ | meth |
			meth := self class lookupSelector: #remoteBreakpointMethod.
			meth setBreakAtStepPoint: 1.
			self remoteBreakpointMethod]! !

!ILGemstonePlatform methodsFor: 'debugging' stamp: 'NicolasPetton 07/08/2011 14:54'!
remoteBreakpointMethod
	"Special marker method ... causes OTRemoteDebugger to be used for debugging"
	
	^self! !

!ILGemstonePlatform methodsFor: 'utilities' stamp: 'SebastienAudier 07/07/2011 14:42'!
setStreamPosition: anInteger of: aStream
	^aStream position: anInteger + 1! !

String variableByteSubclass: #ILId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-GemStone-Core-Utilities'!

!ILId class methodsFor: 'defaults' stamp: 'sa 3/5/2010 18:50'!
defaultSize
	^12! !

!ILId class methodsFor: 'instance creation' stamp: 'np 10/28/2008 20:35'!
new
	^self new: self defaultSize! !

!ILId class methodsFor: 'instance creation' stamp: 'np 10/28/2008 20:37'!
new: anInteger
	^(self basicNew: anInteger)
		initialize;
		yourself! !

!ILId methodsFor: 'initialization' stamp: 'np 4/5/2010 17:24'!
initialize
	GRPlatform current semaphoreClass forMutualExclusion critical: [
		self at: 1 put: ($a to: $z) atRandom.
		2 to: self size do: [:each |
			self at: each put: self table atRandom]]! !

!ILId methodsFor: 'accessing' stamp: 'sa 3/5/2010 18:51'!
table
	^($a to: $z), ($A to: $Z), ($0 to: $9), (Array with: $_ with: $-)! !
ILGemstonePlatform initialize!
